// $Id$
//
// This software was produced by Sigsworth Engineering Services.
// All Rights Reserved, Copyright(C) 1999, Sigsworth Engineering Services.
//
// Project name: random
//
// Project/Contract Number: 8
//
// #A John S Glover
//
//    Description
//    -----------
// #D PRBS random bit generator class

#ifndef PRBS_H
#define PRBS_H

#ifndef ULong
typedef unsigned long ULong;
typedef unsigned short UShort;
#endif

const unsigned uMaxGeneratorLength = 32;

// This is the important bit if need to use the DLL
class Prbs {
  unsigned length;
  ULong ulPrbsValue;
  ULong ulMaxPrbsValue;
  ULong ulPrbsTaps[33];
  ULong ulRandomBit;
  ULong ulMask;

// Following was OK in GCC, Firststep balks at it. Hmmm.
// was ... const unsigned uMaxGeneratorLength = 32;

  friend ostream& operator<<(ostream&, Prbs&);

  public:
    Prbs(void);
    Prbs(const unsigned lengthGenerator, const ULong ulGeneratorSeed);

    int Prbs::setLength(const unsigned lengthGenerator);
    int Prbs::seed(const ULong ulGeneratorSeed);

    int Prbs::advance(void);
    int Prbs::advance(const ULong ulShift);
};  // class Prbs

#endif

// random.h
